﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using VslAustin2018.TddDemo.Api;

namespace VslAustin2018.TddDemo.UnitTests
{
    [TestClass]
    public class CalculatorFixture
    {
        [TestInitialize]
        public void OnTestInitialize()
        {
            _SystemUnderTest = null;
        }
        

        private Calculator _SystemUnderTest;
        public Calculator SystemUnderTest
        {
            get
            {
                if (_SystemUnderTest == null)
                {
                    _SystemUnderTest = new Calculator();
                }

                return _SystemUnderTest;
            }
        }

        [TestMethod]
        public void Add()
        {
            // arrange
            int value1 = 2;
            int value2 = 4;

            int expected = 6;

            // act
            int actual = 
                SystemUnderTest.Add(value1, value2);


            // assert
            Assert.AreEqual<int>(expected, actual, 
                "Got wrong value back.");

        }

        [TestMethod]
        public void Subtract()
        {
            // arrange
            int value1 = 2;
            int value2 = 4;

            int expected = -2;

            // act
            int actual =
                SystemUnderTest.Subtract(value1, value2);


            // assert
            Assert.AreEqual<int>(expected, actual,
                "Got wrong value back.");
        }

        [TestMethod]
        public void Multiply()
        {
            // arrange
            int value1 = 2;
            int value2 = 4;

            int expected = 8;

            // act
            int actual =
                SystemUnderTest.Multiply(value1, value2);


            // assert
            Assert.AreEqual<int>(expected, actual,
                "Got wrong value back.");
        }

        [TestMethod]
        public void Divide()
        {
            // arrange
            int value1 = 4;
            int value2 = 2;

            int expected = 2;

            // act
            int actual =
                SystemUnderTest.Divide(value1, value2);


            // assert
            Assert.AreEqual<int>(expected, actual,
                "Got wrong value back.");
        }

        [TestMethod]
        [ExpectedException(typeof(InvalidOperationException))]
        public void DivideHandlesDivideByZero()
        {
            SystemUnderTest.Divide(5, 0);
        }
    }
}
